diff --git a/applications/luci-olsr/luasrc/view/status-olsr/common_js.htm b/applications/luci-olsr/luasrc/view/status-olsr/common_js.htm
index 1ee763e..1ec07d3 100644
--- a/applications/luci-olsr/luasrc/view/status-olsr/common_js.htm
+++ b/applications/luci-olsr/luasrc/view/status-olsr/common_js.htm
@@ -2,33 +2,33 @@
 <script type="text/javascript">//<![CDATA[
 
 function css(selector, property, value) {
-  for (var i=0; i<document.styleSheets.length;i++) {
-    try { document.styleSheets[i].insertRule(selector+ ' {'+property+':'+value+'}', document.styleSheets[i].cssRules.length);
-    } catch(err) {try { document.styleSheets[i].addRule(selector, property+':'+value);} catch(err) {}}//IE
-  }
+	for (var i=0; i<document.styleSheets.length;i++) {
+		try { document.styleSheets[i].insertRule(selector+ ' {'+property+':'+value+'}', document.styleSheets[i].cssRules.length);
+		} catch(err) {try { document.styleSheets[i].addRule(selector, property+':'+value);} catch(err) {}}//IE
+	}
 }
 
 window.onload = function() {
-  buttons = '<input type="button" name="show-proto-4" id="show-proto-4" class="cbi-button cbi-button-apply" style="margin-right: 5px" value="<%:Hide IPv4%>">'
-  buttons += '<input type="button" name="show-proto-6" id="show-proto-6" class="cbi-button cbi-button-apply" value="<%:Hide IPv6%>">'
+	buttons = '<input type="button" name="show-proto-4" id="show-proto-4" class="cbi-button cbi-button-apply" style="margin-right: 5px" value="<%:Hide IPv4%>">'
+	buttons += '<input type="button" name="show-proto-6" id="show-proto-6" class="cbi-button cbi-button-apply" value="<%:Hide IPv6%>">'
 
-  document.getElementById('togglebuttons').innerHTML = buttons;
+	document.getElementById('togglebuttons').innerHTML = buttons;
 
-  var visible = true;
-  document.getElementById('show-proto-4').onclick = function() {
-  visible = !visible;
-  document.getElementById('show-proto-4').value = visible ? '<%:Hide IPv4%>' : '<%:Show IPv4%>';
-  document.getElementById('show-proto-4').className = visible ? 'cbi-button cbi-button-apply' : 'cbi-button cbi-button-reset';
-  css('.proto-4', 'display', visible ? 'table-row' : 'none')
-  };
-
-  var visible6 = true;
-  document.getElementById('show-proto-6').onclick = function() {
-  visible6 = !visible6;
-  document.getElementById('show-proto-6').value = visible6 ? '<%:Hide IPv6%>' : '<%:Show IPv6%>';
-  document.getElementById('show-proto-6').className = visible6 ? 'cbi-button cbi-button-apply' : 'cbi-button cbi-button-reset';
-  css('.proto-6', 'display', visible6 ? 'table-row' : 'none')
-  };
+	var visible = true;
+	document.getElementById('show-proto-4').onclick = function() {
+		visible = !visible;
+		document.getElementById('show-proto-4').value = visible ? '<%:Hide IPv4%>' : '<%:Show IPv4%>';
+		document.getElementById('show-proto-4').className = visible ? 'cbi-button cbi-button-apply' : 'cbi-button cbi-button-reset';
+		css('.proto-4', 'display', visible ? 'table-row' : 'none')
+	};
+	
+	var visible6 = true;
+	document.getElementById('show-proto-6').onclick = function() {
+		visible6 = !visible6;
+		document.getElementById('show-proto-6').value = visible6 ? '<%:Hide IPv6%>' : '<%:Show IPv6%>';
+		document.getElementById('show-proto-6').className = visible6 ? 'cbi-button cbi-button-apply' : 'cbi-button cbi-button-reset';
+		css('.proto-6', 'display', visible6 ? 'table-row' : 'none')
+	};
 
 }
 //]]></script>
diff --git a/applications/luci-olsr/luasrc/view/status-olsr/hna.htm b/applications/luci-olsr/luasrc/view/status-olsr/hna.htm
index 689bafd..6c8984f 100644
--- a/applications/luci-olsr/luasrc/view/status-olsr/hna.htm
+++ b/applications/luci-olsr/luasrc/view/status-olsr/hna.htm
@@ -68,10 +68,10 @@ XHR.poll(10, '<%=REQUEST_URI%>', { status: 1 },
 			}
 
 			s += String.format(
-                                '<td class="cbi-section-table-cell">%s</td>' +
-                                '<td class="cbi-section-table-cell">%s</td>' +
-                                '<td class="cbi-section-table-cell">%s</td>', hna.destination + '/' + hna.genmask, linkgw + hostname, validity
-                                )
+				'<td class="cbi-section-table-titles">%s</td>' +
+				'<td class="cbi-section-table-titles">%s</td>' +
+				'<td class="cbi-section-table-titles">%s</td>', hna.destination + '/' + hna.genmask, linkgw + hostname, validity
+			)
 			s += '</tr>'
 		}
 		hnadiv.innerHTML = s;
@@ -89,9 +89,9 @@ XHR.poll(10, '<%=REQUEST_URI%>', { status: 1 },
 	<table class="cbi-section-table">
 		<thead>
 		<tr class="cbi-section-table-titles">
-			<th class="cbi-section-table-cell"><%:Announced network%></th>
-			<th class="cbi-section-table-cell"><%:OLSR gateway%></th>
-			<th class="cbi-section-table-cell"><%:Validity Time%></th>
+			<th class="cbi-section-table-titles"><%:Announced network%></th>
+			<th class="cbi-section-table-titles"><%:OLSR gateway%></th>
+			<th class="cbi-section-table-titles"><%:Validity Time%></th>
 		</tr>
 
 		</thead>
@@ -99,8 +99,8 @@ XHR.poll(10, '<%=REQUEST_URI%>', { status: 1 },
 		<% for k, route in ipairs(hna) do %>
 
 		<tr class="cbi-section-table-row cbi-rowstyle-<%=i%> proto-<%=hna[k].proto%>">
-			<td class="cbi-section-table-cell"><%=hna[k].destination%>/<%=hna[k].genmask%> </td>
-			<td class="cbi-section-table-cell">
+			<td class="cbi-section-table-titles"><%=hna[k].destination%>/<%=hna[k].genmask%> </td>
+			<td class="cbi-section-table-titles">
 				<% if hna[k].proto == '6' then %>
 				<a href="http://[<%=hna[k].gateway%>]/cgi-bin-status.html"><%=hna[k].gateway%></a>
 				<% else %>
@@ -116,7 +116,7 @@ XHR.poll(10, '<%=REQUEST_URI%>', { status: 1 },
 				validity = '-'
 			end %>
 
-			<td class="cbi-section-table-cell"><%=validity%></td>
+			<td class="cbi-section-table-titles"><%=validity%></td>
 		</tr>
 
 		<% i = ((i % 2) + 1)
diff --git a/applications/luci-olsr/luasrc/view/status-olsr/interfaces.htm b/applications/luci-olsr/luasrc/view/status-olsr/interfaces.htm
index dd1a21e..423115b 100644
--- a/applications/luci-olsr/luasrc/view/status-olsr/interfaces.htm
+++ b/applications/luci-olsr/luasrc/view/status-olsr/interfaces.htm
@@ -39,13 +39,13 @@ local i = 1
 		<% for k, iface in ipairs(iface) do %>
 
 		<tr class="cbi-section-table-row cbi-rowstyle-<%=i%> proto-<%=iface.proto%>">
-			<td class="cbi-section-table-cell"><%=iface.name%></td>
-			<td class="cbi-section-table-cell"><%=iface.state%></td>
-			<td class="cbi-section-table-cell"><%=iface.olsrMTU%></td>
-			<td class="cbi-section-table-cell"><%=iface.wireless and luci.i18n.translate('yes') or luci.i18n.translate('no')%></td>
-			<td class="cbi-section-table-cell"><%=iface.ipv4Address or iface.ipv6Address%></td>
-			<td class="cbi-section-table-cell"><%=iface.netmask%></td>
-			<td class="cbi-section-table-cell"><%=iface.broadcast or iface.multicast%></td>
+			<td class="cbi-section-table-titles"><%=iface.name%></td>
+			<td class="cbi-section-table-titles"><%=iface.state%></td>
+			<td class="cbi-section-table-titles"><%=iface.olsrMTU%></td>
+			<td class="cbi-section-table-titles"><%=iface.wireless and luci.i18n.translate('yes') or luci.i18n.translate('no')%></td>
+			<td class="cbi-section-table-titles"><%=iface.ipv4Address or iface.ipv6Address%></td>
+			<td class="cbi-section-table-titles"><%=iface.netmask%></td>
+			<td class="cbi-section-table-titles"><%=iface.broadcast or iface.multicast%></td>
 		</tr>
 		<% i = ((i % 2) + 1)
 		end %>
diff --git a/applications/luci-olsr/luasrc/view/status-olsr/mid.htm b/applications/luci-olsr/luasrc/view/status-olsr/mid.htm
index ec5caaa..2a78567 100644
--- a/applications/luci-olsr/luasrc/view/status-olsr/mid.htm
+++ b/applications/luci-olsr/luasrc/view/status-olsr/mid.htm
@@ -25,8 +25,8 @@ local i = 1
 	<legend><%:Overview of known multiple interface announcements%></legend>
 	<table class="cbi-section-table">
 		<tr class="cbi-section-table-titles">
-			<th class="cbi-section-table-cell"><%:OLSR node%></th>
-			<th class="cbi-section-table-cell" ><%:Secondary OLSR interfaces%></th>
+			<th class="cbi-section-table-titles"><%:OLSR node%></th>
+			<th class="cbi-section-table-titles" ><%:Secondary OLSR interfaces%></th>
 		</tr>
 
 		<% for k, mid in ipairs(mids) do 
@@ -46,8 +46,8 @@ local i = 1
 		%>
 
 		<tr class="cbi-section-table-row cbi-rowstyle-<%=i%> proto-<%=mid.proto%>">
-			<td class="cbi-section-table-cell"><a href="http://<%=host%>/cgi-bin-status.html"><%=mid.ipAddress%></a></td>
-			<td class="cbi-section-table-cell"><%=aliases%></td>
+			<td class="cbi-section-table-titles"><a href="http://<%=host%>/cgi-bin-status.html"><%=mid.ipAddress%></a></td>
+			<td class="cbi-section-table-titles"><%=aliases%></td>
 		</tr>
 
 		<% i = ((i % 2) + 1)
diff --git a/applications/luci-olsr/luasrc/view/status-olsr/neighbors.htm b/applications/luci-olsr/luasrc/view/status-olsr/neighbors.htm
index daa5283..fcb238f 100644
--- a/applications/luci-olsr/luasrc/view/status-olsr/neighbors.htm
+++ b/applications/luci-olsr/luasrc/view/status-olsr/neighbors.htm
@@ -122,14 +122,14 @@ end
 	<table class="cbi-section-table">
 		<thead>
 			<tr class="cbi-section-table-titles">
-				<th class="cbi-section-table-cell"><%:Neighbour IP%></th>
-				<th class="cbi-section-table-cell"><%:Hostname%></th>
-				<th class="cbi-section-table-cell"><%:Interface%></th>
-				<th class="cbi-section-table-cell"><%:Local interface IP%></th>
-				<th class="cbi-section-table-cell">LQ</th>
-				<th class="cbi-section-table-cell">NLQ</th>
-				<th class="cbi-section-table-cell">ETX</th>
-				<th class="cbi-section-table-cell">SNR</th>
+				<th class="cbi-section-table-titles"><%:Neighbour IP%></th>
+				<th class="cbi-section-table-titles"><%:Hostname%></th>
+				<th class="cbi-section-table-titles"><%:Interface%></th>
+				<th class="cbi-section-table-titles"><%:Local interface IP%></th>
+				<th class="cbi-section-table-titles">LQ</th>
+				<th class="cbi-section-table-titles">NLQ</th>
+				<th class="cbi-section-table-titles">ETX</th>
+				<th class="cbi-section-table-titles">SNR</th>
 			</tr>
 		</thead>
 	
diff --git a/applications/luci-olsr/luasrc/view/status-olsr/overview.htm b/applications/luci-olsr/luasrc/view/status-olsr/overview.htm
index 6d8eca8..d782136 100644
--- a/applications/luci-olsr/luasrc/view/status-olsr/overview.htm
+++ b/applications/luci-olsr/luasrc/view/status-olsr/overview.htm
@@ -162,50 +162,48 @@ XHR.poll(10, '<%=REQUEST_URI%>/json', { },
 <h2><a id="content" name="content">OLSR <%:Overview%></a></h2>
 
 <fieldset class="cbi-section">
-        <legend><%:Network%></legend>
+	<legend><%:Network%></legend>
 
-        <table width="100%" cellspacing="10">
-                <tr><td width="33%"><%:Interfaces%></td><td>
+	<table width="100%" cellspacing="10">
+		<tr><td width="33%"><%:Interfaces%></td><td>
 			<a href="<%=REQUEST_URI%>/interfaces">
 				<span id="nr_ifaces">-<span>
 			</a>
 		</td></tr>
-                <tr><td width="33%"><%:Neighbors%></td><td>
+		<tr><td width="33%"><%:Neighbors%></td><td>
 			<a href="<%=REQUEST_URI%>/neighbors">
 				<span id="nr_neigh">-</span>
 			</a>
 		</td></tr>
-                <tr><td width="33%"><%:Nodes%></td><td>
+		<tr><td width="33%"><%:Nodes%></td><td>
 			<a href="<%=REQUEST_URI%>/topology">
 				<span id="nr_nodes">-</span>
-			</a>
+				</a>
 		</td></tr>
-                <tr><td width="33%"><%:HNA%></td><td>
+		<tr><td width="33%"><%:HNA%></td><td>
 			<a href="<%=REQUEST_URI%>/hna">
 				<span id="nr_hna">-</span>
 			</a>
 		</td></tr>
-                <tr><td width="33%"><%:Links total%></td><td>
+		<tr><td width="33%"><%:Links total%></td><td>
 			<a href="<%=REQUEST_URI%>/topology">
 				<span id="nr_topo">-</span>
 			</a>
 		</td></tr>
-                <tr><td width="33%"><%:Links per node (average)%></td><td>
+		<tr><td width="33%"><%:Links per node (average)%></td><td>
 			<span id="meshfactor">-</span>
 		</td></tr>
-
-
-        </table>
+	</table>
 </fieldset>
 
 
 <fieldset class="cbi-section">
-        <legend>OLSR <%:Configuration%></legend>
-        <table width="100%" cellspacing="10">
-                <tr><td width="33%"><%:Version%></td><td>
-			<span id="version">-<span>
-		</td></tr>
-                <tr><td width="33%"><%:Download Config%></td><td>
+	<legend>OLSR <%:Configuration%></legend>
+	<table width="100%" cellspacing="10">
+			<tr><td width="33%"><%:Version%></td><td>
+				<span id="version">-<span>
+			</td></tr>
+			<tr><td width="33%"><%:Download Config%></td><td>
 				<a href="<%=REQUEST_URI%>?openwrt">OpenWrt</a>,
 				<% if ipv == "6and4" then %>
 					<a href="<%=REQUEST_URI%>?conf_v4">OLSRD IPv4</a>,
@@ -213,7 +211,7 @@ XHR.poll(10, '<%=REQUEST_URI%>/json', { },
 				<% else %>
 					<a href="<%=REQUEST_URI%>?conf">OLSRD</a>
 				<% end %>
-		</td></tr>
+			</td></tr>
 	</table>
 </fieldset>
 
diff --git a/applications/luci-olsr/luasrc/view/status-olsr/routes.htm b/applications/luci-olsr/luasrc/view/status-olsr/routes.htm
index 76e1b10..33eba02 100644
--- a/applications/luci-olsr/luasrc/view/status-olsr/routes.htm
+++ b/applications/luci-olsr/luasrc/view/status-olsr/routes.htm
@@ -22,7 +22,7 @@ if luci.http.formvalue("status") == "1" then
 		local ETX = string.format("%.3f", tonumber(route.rtpMetricCost)/1024 or 0)
 		rv[#rv+1] = {
 			hostname = route.hostname,
-	                dest = route.destination,
+			dest = route.destination,
 			genmask = route.genmask,
 			gw = route.gateway,
 			interface = route.networkInterface,
@@ -57,38 +57,37 @@ XHR.poll(20, '<%=REQUEST_URI%>', { status: 1 },
 
 					s += String.format(
 						'<tr class="cbi-section-table-row cbi-rowstyle-'+(1 + (idx % 2))+' proto-%s">' +
-							'<td class="cbi-section-table-cell">%s/%s</td>' +
-							'<td class="cbi-section-table-cell">' +
-			                	                '<a href="http://%s/cgi-bin-status.html">%s</a>',
-								route.proto, route.dest, route.genmask, route.gw, route.gw
-						)
+						'<td class="cbi-section-table-titles">%s/%s</td>' +
+						'<td class="cbi-section-table-titles">' +
+						'<a href="http://%s/cgi-bin-status.html">%s</a>',
+						route.proto, route.dest, route.genmask, route.gw, route.gw
+					)
 
 					if (route.hostname) {
 						if (hna.proto == '6') {
 							s += String.format(
-			                                        ' / <a href="http://[%s]/cgi-bin-status.html">%s</a>',
+								' / <a href="http://[%s]/cgi-bin-status.html">%s</a>',
 								route.hostname, route.hostname || '?'
-								);
+							);
 						} else {
 							s += String.format(
-			                                        ' / <a href="http://%s/cgi-bin-status.html">%s</a>',
+								' / <a href="http://%s/cgi-bin-status.html">%s</a>',
 								route.hostname, route.hostname || '?'
-								);
+							);
 						}
 
 					}
 					s += String.format(
-				                        '</td>' +
-							'<td class="cbi-section-table-cell">%s</td>' +
-							'<td class="cbi-section-table-cell">%s</td>' +
-							'<td class="cbi-section-table-cell" style="background-color:%s">%s</td>' +
+							'</td>' +
+							'<td class="cbi-section-table-titles">%s</td>' +
+							'<td class="cbi-section-table-titles">%s</td>' +
+							'<td class="cbi-section-table-titles" style="background-color:%s">%s</td>' +
 						'</tr>',
 						route.interface, route.metric, route.color, route.etx || '?'
 					);
 				}
-                        }
-			 rt.innerHTML = s;
-
+			}
+			rt.innerHTML = s;
 		}
 	);
 //]]></script>
@@ -121,8 +120,8 @@ XHR.poll(20, '<%=REQUEST_URI%>', { status: 1 },
 	%>
 
 		<tr class="cbi-section-table-row cbi-rowstyle-<%=i%> proto-<%=route.proto%>">
-			<td class="cbi-section-table-cell"><%=route.destination%>/<%=route.genmask%></td>
-			<td class="cbi-section-table-cell">
+			<td class="cbi-section-table-titles"><%=route.destination%>/<%=route.genmask%></td>
+			<td class="cbi-section-table-titles">
 				<% if route.proto == '6' then %>
 				<a href="http://[<%=route.gateway%>]/cgi-bin-status.html"><%=route.gateway%></a>
 				<% else  %>
@@ -132,9 +131,9 @@ XHR.poll(20, '<%=REQUEST_URI%>', { status: 1 },
 					/ <a href="http://<%=route.Hostname%>/cgi-bin-status.html"><%=route.hostname%></a>  
 				<% end %>
 			</td>
-			<td class="cbi-section-table-cell"><%=route.networkInterface%></td>
-			<td class="cbi-section-table-cell"><%=route.metric%></td>
-			<td class="cbi-section-table-cell" style="background-color:<%=color%>"><%=string.format("%.3f", ETX)%></td>
+			<td class="cbi-section-table-titles"><%=route.networkInterface%></td>
+			<td class="cbi-section-table-titles"><%=route.metric%></td>
+			<td class="cbi-section-table-titles" style="background-color:<%=color%>"><%=string.format("%.3f", ETX)%></td>
 		</tr>
 	<% 
 		i = ((i % 2) + 1)
diff --git a/applications/luci-olsr/luasrc/view/status-olsr/smartgw.htm b/applications/luci-olsr/luasrc/view/status-olsr/smartgw.htm
index 75d0c1c..cefb896 100644
--- a/applications/luci-olsr/luasrc/view/status-olsr/smartgw.htm
+++ b/applications/luci-olsr/luasrc/view/status-olsr/smartgw.htm
@@ -17,7 +17,7 @@ require("luci.model.uci")
 local uci = luci.model.uci.cursor_state()
 
 uci:foreach("olsrd", "olsrd", function(s)
-        if s.SmartGateway and s.SmartGateway == "yes" then has_smartgw  = true end
+	if s.SmartGateway and s.SmartGateway == "yes" then has_smartgw  = true end
 end)
 
 
@@ -25,9 +25,9 @@ if luci.http.formvalue("status") == "1" then
 	local rv = {}
 	for k, gw in ipairs(gws) do
 		gw.tcPathCost = tonumber(gw.tcPathCost)/1024 or 0
-                if gw.tcPathCost == 4096 then
-                        gw.tcPathCost = 0
-                end
+		if gw.tcPathCost == 4096 then
+			gw.tcPathCost = 0
+		end
 
 		rv[#rv+1] = {
 			proto = gw.proto,
@@ -70,17 +70,17 @@ XHR.poll(10, '<%=REQUEST_URI%>', { status: 1 },
 			}
 
 			s += String.format(
-                                '<td class="cbi-section-table-cell">%s</td>' +
-                                '<td class="cbi-section-table-cell">%s</td>' +
-                                '<td class="cbi-section-table-cell">%s</td>' +
-                                '<td class="cbi-section-table-cell">%s</td>' +
-                                '<td class="cbi-section-table-cell">%s</td>' +
-                                '<td class="cbi-section-table-cell">%s</td>' +
-                                '<td class="cbi-section-table-cell">%s</td>' +
-                                '<td class="cbi-section-table-cell">%s</td>' +
-                                '<td class="cbi-section-table-cell">%s</td>',
+				'<td class="cbi-section-table-titles">%s</td>' +
+				'<td class="cbi-section-table-titles">%s</td>' +
+				'<td class="cbi-section-table-titles">%s</td>' +
+				'<td class="cbi-section-table-titles">%s</td>' +
+				'<td class="cbi-section-table-titles">%s</td>' +
+				'<td class="cbi-section-table-titles">%s</td>' +
+				'<td class="cbi-section-table-titles">%s</td>' +
+				'<td class="cbi-section-table-titles">%s</td>' +
+				'<td class="cbi-section-table-titles">%s</td>',
 				linkgw, smartgw.status, smartgw.tcPathCost, smartgw.hopCount, smartgw.uplinkSpeed, smartgw.downlinkSpeed, smartgw.v4, smartgw.v6, smartgw.externalPrefix
-                                )
+			)
 			s += '</tr>'
 		}
 		smartgwdiv.innerHTML = s;
@@ -103,15 +103,15 @@ XHR.poll(10, '<%=REQUEST_URI%>', { status: 1 },
 		<table class="cbi-section-table">
 			<thead>
 			<tr class="cbi-section-table-titles">
-				<th class="cbi-section-table-cell"><%:Gateway%></th>
-				<th class="cbi-section-table-cell"><%:Status%></th>
-				<th class="cbi-section-table-cell"><%:ETX%></th>
-				<th class="cbi-section-table-cell"><%:Hops%></th>
-				<th class="cbi-section-table-cell"><%:Uplink%></th>
-				<th class="cbi-section-table-cell"><%:Downlink%></th>
-				<th class="cbi-section-table-cell"><%:IPv4%></th>
-				<th class="cbi-section-table-cell"><%:IPv6%></th>
-				<th class="cbi-section-table-cell"><%:Prefix%></th>
+				<th class="cbi-section-table-titles"><%:Gateway%></th>
+				<th class="cbi-section-table-titles"><%:Status%></th>
+				<th class="cbi-section-table-titles"><%:ETX%></th>
+				<th class="cbi-section-table-titles"><%:Hops%></th>
+				<th class="cbi-section-table-titles"><%:Uplink%></th>
+				<th class="cbi-section-table-titles"><%:Downlink%></th>
+				<th class="cbi-section-table-titles"><%:IPv4%></th>
+				<th class="cbi-section-table-titles"><%:IPv6%></th>
+				<th class="cbi-section-table-titles"><%:Prefix%></th>
 
 			</tr>
 			</thead>
@@ -120,9 +120,9 @@ XHR.poll(10, '<%=REQUEST_URI%>', { status: 1 },
 			<% for k, gw in ipairs(gws) do 
 
 			gw.tcPathCost = tonumber(gw.tcPathCost)/1024 or 0
-               		if gw.tcPathCost == 4096 then
-	                        gw.tcPathCost = 0
-               		end
+			if gw.tcPathCost == 4096 then
+				gw.tcPathCost = 0
+			end
 			%>
 
 			<tr class="cbi-section-table-row cbi-rowstyle-<%=i%> proto-<%=proto%>">
@@ -132,14 +132,14 @@ XHR.poll(10, '<%=REQUEST_URI%>', { status: 1 },
 					<td class="cbi-section-table-cell"><a href="http://<%=gw.ipAddress%>/cgi-bin-status.html"><%=gw.ipAddress%></a></td>
 				<% end %>
 
-				<td class="cbi-section-table-cell"><%=gw.ipv4Status or gw.ipv6Status or '-' %></td>
-				<td class="cbi-section-table-cell"><%=string.format("%.3f", gw.tcPathCost)%></td>
-				<td class="cbi-section-table-cell"><%=gw.hopCount%></td>
-				<td class="cbi-section-table-cell"><%=gw.uplinkSpeed%></td>
-				<td class="cbi-section-table-cell"><%=gw.downlinkSpeed%></td>
-				<td class="cbi-section-table-cell"><%=gw.ipv4 and luci.i18n.translate('yes') or luci.i18n.translate('no')%></td>
-				<td class="cbi-section-table-cell"><%=gw.ipv6 and luci.i18n.translate('yes') or luci.i18n.translate('no')%></td>
-				<td class="cbi-section-table-cell"><%=gw.externalPrefix%></td>
+				<td class="cbi-section-table-titles"><%=gw.ipv4Status or gw.ipv6Status or '-' %></td>
+				<td class="cbi-section-table-titles"><%=string.format("%.3f", gw.tcPathCost)%></td>
+				<td class="cbi-section-table-titles"><%=gw.hopCount%></td>
+				<td class="cbi-section-table-titles"><%=gw.uplinkSpeed%></td>
+				<td class="cbi-section-table-titles"><%=gw.downlinkSpeed%></td>
+				<td class="cbi-section-table-titles"><%=gw.ipv4 and luci.i18n.translate('yes') or luci.i18n.translate('no')%></td>
+				<td class="cbi-section-table-titles"><%=gw.ipv6 and luci.i18n.translate('yes') or luci.i18n.translate('no')%></td>
+				<td class="cbi-section-table-titles"><%=gw.externalPrefix%></td>
 			</tr>
 
 			<% i = ((i % 2) + 1)
diff --git a/applications/luci-olsr/luasrc/view/status-olsr/topology.htm b/applications/luci-olsr/luasrc/view/status-olsr/topology.htm
index eb3df5f..904d829 100644
--- a/applications/luci-olsr/luasrc/view/status-olsr/topology.htm
+++ b/applications/luci-olsr/luasrc/view/status-olsr/topology.htm
@@ -43,19 +43,19 @@ local olsrtools = require "luci.tools.olsr"
 
 			<% if route.proto == "6" then %>
 
-			<td class="cbi-section-table-cell"><a href="http://[<%=route.destinationIP%>]/cgi-bin-status.html"><%=route.destinationIP%></a></td>
-			<td class="cbi-section-table-cell"><a href="http://[<%=route.lastHopIP%>]/cgi-bin-status.html"><%=route.lastHopIP%></a></td>
+			<td class="cbi-section-table-titles"><a href="http://[<%=route.destinationIP%>]/cgi-bin-status.html"><%=route.destinationIP%></a></td>
+			<td class="cbi-section-table-titles"><a href="http://[<%=route.lastHopIP%>]/cgi-bin-status.html"><%=route.lastHopIP%></a></td>
 
 			<% else %>
 
-			<td class="cbi-section-table-cell"><a href="http://<%=route.destinationIP%>/cgi-bin-status.html"><%=route.destinationIP%></a></td>
-			<td class="cbi-section-table-cell"><a href="http://<%=route.lastHopIP%>/cgi-bin-status.html"><%=route.lastHopIP%></a></td>
+			<td class="cbi-section-table-titles"><a href="http://<%=route.destinationIP%>/cgi-bin-status.html"><%=route.destinationIP%></a></td>
+			<td class="cbi-section-table-titles"><a href="http://<%=route.lastHopIP%>/cgi-bin-status.html"><%=route.lastHopIP%></a></td>
 
 			<%end%>
 
-			<td class="cbi-section-table-cell"><%=lq%></td>
-			<td class="cbi-section-table-cell"><%=nlq%></td>
-			<td class="cbi-section-table-cell" style="background-color:<%=color%>"><%=cost%></td>
+			<td class="cbi-section-table-titles"><%=lq%></td>
+			<td class="cbi-section-table-titles"><%=nlq%></td>
+			<td class="cbi-section-table-titles" style="background-color:<%=color%>"><%=cost%></td>
 		</tr>
 
 		<%	i = ((i % 2) + 1)